/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: xml.gi,v 1.1 2002/08/12 12:42:15 malekith Exp $
 *
 * Addons library for Gont, Xml module interface.
 */

type doc

union node {
	*[string, <node>List::t, <*[string, string]>List::t] Element;
	string Text;
}

doc parse_file(string filename, bool skip_spaces);
doc parse_string(string xml, bool skip_spaces);
node root_node(doc);

doc make_doc(node root);
string string_of_doc(doc);
string string_of_doc_indented(doc);

node make_text_node(string s);
node make_element_node(string name, <node>List::t children,
			<*[string, string]>List::t);
void save_to_stream(doc, Stdio::FILE f);
void save_to_stream_indented(doc, Stdio::FILE f);

// Node manipulation functions.
// can raise Not_found
node find_element(string name, node n);
// ditto
string prop_value(string name, node n);
// can raise Invalid_argument
string prop_value_default(string name, node n, string def);

exception string Parse_error;
